typedef void (NDKDlgControl::*NDKPNOTIFFN)(int);
typedef void (NDKDlgControl::*NDKPCMDFN)();

struct BINDING
{
	BINDING(int w,int from,int to,NDKPNOTIFFN pf)
	:what(w)
	,ctrl_id(from)
	,last_ctrl_id(to)
	,p_notif_fn(pf)
	{};
	
	BINDING(int w,int from,int to,NDKPCMDFN pf)
	:what(w)
	,ctrl_id(from)
	,last_ctrl_id(to)
	,p_cmd_fn(pf)
	{};
	
	int what;
	int ctrl_id;
	int last_ctrl_id;
	union{
		NDKPNOTIFFN p_notif_fn;
		NDKPCMDFN p_cmd_fn;
	};
	bool pfn()const {return (p_notif_fn || p_cmd_fn);};
};
 
template <class T> 
class BINDING_IMPL //: public BINDING
{
	public:
	T pfn;
	
	BINDING_IMPL(int w,int from_id,int to_id, T fn)
//	:BINDING(w,from_id,to_id)
	:pfn(fn)
	{ f=pfn;}
	
//	union{
//		NDKPNOTIFFN p_notif_fn;
//		NDKPCMDFN p_cmd_fn;
	 
//	};
};

typedef BINDING_IMPL< NDKPNOTIFFN > NotificationBind;
typedef BINDING_IMPL< NDKPCMDFN > CommandBind;

struct BINDING_MAP{
	const BINDING_MAP *base_map;
	const BINDING * pEntries;
};

#define DECLARE_BINDINGS() \
private: \
	static const BINDING _bindingEntries[]; \
protected: \
	static const BINDING_MAP bindingMap; \
	virtual const BINDING_MAP* get_binding_map() const; \

#define BEGIN_FIRST_BINDINGS(theClass) \
	const BINDING_MAP* theClass::get_binding_map() const \
		{ return &theClass::bindingMap; } \
	const BINDING_MAP theClass::bindingMap = \
	{ 0, &theClass::_bindingEntries[0] }; \
	const BINDING theClass::_bindingEntries[] = \
	{ \

#define BEGIN_BINDINGS(theClass, baseClass) \
	const BINDING_MAP* theClass::get_binding_map() const \
		{ return &theClass::bindingMap; } \
	const BINDING_MAP theClass::bindingMap = \
	{ &baseClass::bindingMap, &theClass::_bindingEntries[0] }; \
	const BINDING theClass::_bindingEntries[] = \
	{ \

#define END_BINDINGS() \
		BINDING(0,0,0,(NDKPCMDFN)0) \
	}; \


#define ON_COMMAND(id, memberFxn) \
	BINDING(0, id, id, (NDKPCMDFN) &memberFxn) ,
		// ON_COMMAND(id, OnFoo) is the same as
		//   ON_CONTROL(0, id, OnFoo) or ON_BN_CLICKED(0, id, OnFoo)

#define ON_COMMAND_RANGE(id, idLast, memberFxn) \
	BINDING(0,id, idLast, (NDKPCMDFN) &memberFxn) ,
		// ON_COMMAND_RANGE(id, idLast, OnFoo) is the same as
		//   ON_CONTROL_RANGE(0, id, idLast, OnFoo)

#define ON_NOTIFY(wNotifyCode, id, memberFxn) \
	BINDING(wNotifyCode, id, id, (NDKPNOTIFFN) &memberFxn) ,

#define ON_NOTIFY_RANGE(wNotifyCode, id, idLast, memberFxn) \
	BINDING(wNotifyCode, id, idLast, (NDKPNOTIFFN) &memberFxn) ,

// for general controls
#define ON_CONTROL(wNotifyCode, id, memberFxn) \
	BINDING(wNotifyCode, id, id ,(NDKPNOTIFFN) &memberFxn ),

