// * This makes emacs happy -*-Mode: C++;-*-
/****************************************************************************
 * Copyright (c) 2002 Fabrica de Software XXI SRL - info@lafabrica.com.ar	*
 * Copyright (c) 2002 RaqLink SA - info@raqlink.com							*
 *                                                                          *
 * Permission is hereby granted, free of charge, to any person obtaining a  *
 * copy of this software and associated documentation files (the            *
 * "Software"), to deal in the Software without restriction, including      *
 * without limitation the rights to use, copy, modify, merge, publish,      *
 * distribute, distribute with modifications, sublicense, and/or sell       *
 * copies of the Software, and to permit persons to whom the Software is    *
 * furnished to do so, subject to the following conditions:                 *
 *                                                                          *
 * The above copyright notice and this permission notice shall be included  *
 * in all copies or substantial portions of the Software.                   *
 *                                                                          *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               *
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   *
 * IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   *
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    *
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    *
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               *
 *                                                                          *
 * Except as contained in this notice, the name(s) of the above copyright   *
 * holders shall not be used in advertising or otherwise to promote the     *
 * sale, use or other dealings in this Software without prior written       *
 * authorization.                                                           *
 ****************************************************************************/

/****************************************************************************
 *	Author Miguel Pinkas <miguel@lafabrica.com.ar> 							*
 ****************************************************************************/

#include <ndk++.h>

using namespace NDK_XX;

/************************************************************************
*  	class TestBox														*
* 	Developer's aid... ;-)												*
************************************************************************/
class TestBox: public NDKDialogBox
{
public:
	TestBox(const string &title,int lines, int cols,int y, int x);
protected:
	///we override this to add 
	///adornments to the window
	void on_dlg_init();
	
	/// Called when the "Clear" button is pushed
	void on_clear_list();

	/** 
		Called when the "Remove" button is pushed.
	 	we will remove the item pointed out by the 
	 	second list box, the one with First, 
	 	Last and Middle radio buttons 
	*/
	void on_remove();
	
	NDKDlgEdit *pEdit;
	NDKDlgSelectionBox *pSel;
	NDKDlgChoiceBox *pChoice;
	NDKDlgCheckListBox *pCheckList;
	NDKDlgCheckListBox *pCheckList2;
	
	DECLARE_BINDINGS();

	/**
		Called whenever the pChoice listbox 
		selection changes.
		It is binded to the LI_SEL_CHANGE event 
		via the BINDING... macros
	*/
	void on_sel_change(int id);
	
	/**
		If we remove something we must update 
		the items pointed to by the pChoice items
	*/
	void refresh_choices();
};


/************************************************************************
*  	clase ShowTestDialogCmd												*
* 	When pushed it shows the TestDlg window.							*
************************************************************************/
class ShowTestDialogCmd : public NDKMenuItem
{
public:
  	ShowTestDialogCmd() : NDKMenuItem("Test Dialog") { }
  	~ShowTestDialogCmd(){}
  	bool action() { 
		TestBox test("Title",18,55,4,5);
		test.do_modal();
  		return FALSE; 
	}
};


/************************************************************************
*  	clase APopUpCmd														*
************************************************************************/
class APopUpCmd : public NDKPopUpMenu
{
public:
	APopUpCmd ();
	~APopUpCmd(){}
};


/************************************************************************
*  	clase AnotherPopUpCmd												*
************************************************************************/
class AnotherPopUpCmd : public NDKPopUpMenu
{
public:
  	AnotherPopUpCmd();
  	~AnotherPopUpCmd(){}
};


/************************************************************************
*  	class TestApplication												*
************************************************************************/
class TestApplication : public NDKApplication {
protected:
	int titlesize() const { return 1; }
	void title();
	void activateMenuBar(ListOfItems &items);
public:
	TestApplication() : NDKApplication(TRUE) {  }
	int run();
};

